/* fe-supervisor.js */
(function(g,f){typeof exports==='object'&&typeof module!=='undefined'?f(exports):typeof define==='function'&&define.amd?define(['exports'],f):(g=g||self,f(g.$sv={}));}(this,function(exports){'use strict';/*! *****************************************************************************
Copyright (c) Microsoft Corporation. All rights reserved.
Licensed under the Apache License, Version 2.0 (the "License"); you may not use
this file except in compliance with the License. You may obtain a copy of the
License at http://www.apache.org/licenses/LICENSE-2.0

THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
MERCHANTABLITY OR NON-INFRINGEMENT.

See the Apache Version 2.0 License for specific language governing permissions
and limitations under the License.
***************************************************************************** */

var __assign = function() {
    __assign = Object.assign || function __assign(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};

function __awaiter(thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

function __generator(thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
}var addListener = (function () {
    if (typeof window === 'undefined')
        return function () { };
    if (!window.addEventListener) {
        return function (event, fn, dom) {
            var eventDOM = dom || window;
            eventDOM.attachEvent("on" + event, fn);
        };
    }
    return function (event, fn, dom, useCapture) {
        if (useCapture === void 0) { useCapture = false; }
        var eventDOM = dom || window;
        eventDOM.addEventListener(event, fn, useCapture);
    };
})();var removeListener = (function () {
    if (typeof window === 'undefined')
        return function () { };
    if (!window.removeEventListener) {
        return function (event, fn, dom) {
            var eventDOM = dom || window;
            eventDOM.detachEvent("on" + event, fn);
        };
    }
    return function (event, fn, dom, useCapture) {
        if (useCapture === void 0) { useCapture = false; }
        var eventDOM = dom || window;
        eventDOM.removeEventListener(event, fn, useCapture);
    };
})();var getType = function (ele) {
    if (typeof ele !== 'object')
        return typeof ele;
    var len = Object.prototype.toString.call(ele).length - 1;
    return Object.prototype.toString.call(ele).slice(8, len).toLowerCase();
};function notSupport() {
    console.warn('Your browser not support the [Performance] API!');
    return false;
}var longTaskThreshold = 50;
var singleTaskThreshold = longTaskThreshold / 2;
var notGF = function () {
    console.warn('Please pass the [Generator Function]');
    return false;
};
var timeslice = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (genF) {
        if (!genF || typeof genF !== 'function')
            return notGF;
        var gen = genF();
        if (typeof gen.next !== 'function')
            return notGF;
        return new Promise(function (resolve, reject) {
            function next() {
                try {
                    var start = performance.now();
                    var res = null;
                    do {
                        res = gen.next();
                    } while (!res.done && performance.now() - start < singleTaskThreshold);
                    if (res.done) {
                        resolve(res.value);
                        return;
                    }
                    setTimeout(next);
                }
                catch (err) {
                    reject(err);
                }
            }
            next();
        });
    };
})();var parseUrl = (function () {
    if (typeof window === 'undefined')
        return;
    var HTTP_PORT = '80';
    var HTTPS_PORT = '443';
    var DEFAULT_PORT = RegExp(':(' + HTTP_PORT + '|' + HTTPS_PORT + ')$');
    var a = document.createElement('a');
    var cache = {};
    return function parse_url(url) {
        url = (!url || url == '.') ? location.href : url;
        if (cache[url])
            return cache[url];
        a.href = url;
        if (url.charAt(0) == '.' || url.charAt(0) == '/')
            return parse_url(a.href);
        var port = (a.port == HTTP_PORT || a.port == HTTPS_PORT) ? '' : a.port;
        port = port == '0' ? '' : port;
        var host = a.host.replace(DEFAULT_PORT, '');
        var origin = a.origin ? a.origin : a.protocol + '//' + host;
        var pathname = a.pathname.charAt(0) == '/' ? a.pathname : '/' + a.pathname;
        return cache[url] = {
            hash: a.hash,
            host: host,
            hostname: a.hostname,
            href: a.href,
            origin: origin,
            pathname: pathname,
            port: port,
            protocol: a.protocol,
            search: a.search,
        };
    };
})();var storage = (function () {
    if (typeof window === 'undefined' || !window.sessionStorage || !window.localStorage)
        return {
            get: function () { return null; },
            set: function () { return false; },
            clear: function () { return false; }
        };
    var handleStorage = {
        sessionStorage: {
            set: function (key, val) {
                var res;
                try {
                    window.sessionStorage.setItem(key, val);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            },
            get: function (key) {
                var res;
                try {
                    res = window.sessionStorage.getItem(key);
                }
                catch (err) {
                    res = null;
                }
                return res;
            },
            clear: function (key) {
                var res;
                try {
                    window.sessionStorage.removeItem(key);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            }
        },
        localStorage: {
            set: function (key, val) {
                var res;
                try {
                    window.localStorage.setItem(key, val);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            },
            get: function (key) {
                var res;
                try {
                    res = window.localStorage.getItem(key);
                }
                catch (err) {
                    res = null;
                }
                return res;
            },
            clear: function (key) {
                var res;
                try {
                    window.localStorage.removeItem(key);
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            }
        },
        cookie: {
            set: function (key, val, option) {
                var res;
                try {
                    var _a = option || {}, _b = _a.domain, domain = _b === void 0 ? '' : _b, _c = _a.path, path = _c === void 0 ? '/' : _c, _d = _a.expires, expires = _d === void 0 ? 0 : _d, _e = _a.secure, secure = _e === void 0 ? false : _e;
                    var ts = void 0;
                    if (expires >= 0) {
                        ts = new Date();
                        ts.setTime(ts.getTime() + expires * 1000);
                    }
                    document.cookie = key + "=" + val + ";domain=" + domain + ";path=" + path + ";expires=" + (ts ? ts.toUTCString() : '') + ";" + (secure ? 'secure' : '');
                    res = true;
                }
                catch (err) {
                    res = false;
                }
                return res;
            },
            get: function (key) {
                var reg = new RegExp('(^| )' + key + '=([^;]*)(;|$)');
                var cookArr = document.cookie.match(reg);
                if (cookArr && cookArr[2]) {
                    return unescape(cookArr[2]);
                }
                return null;
            },
            clear: function (key, domain) {
                document.cookie = key + "=\"\";domain=" + domain + ";max-age=-1";
                var res = handleStorage.cookie.get(key);
                return !!res;
            }
        },
        get: function (key, storeType) {
            try {
                if (typeof storeType === 'string' && handleStorage[storeType]) {
                    return handleStorage[storeType].get(key);
                }
                return this.cookie.get(key) || this.localStorage.get(key) || this.sessionStorage.get(key);
            }
            catch (e) {
                return null;
            }
        },
        set: function (key, val, storeType, option) {
            var res;
            try {
                if (typeof storeType === 'string' && handleStorage[storeType]) {
                    res = handleStorage[storeType].set(key, val, option);
                }
                else if (option) {
                    res = handleStorage.cookie.set(key, val, option);
                }
                else {
                    res = handleStorage.localStorage.set(key, val);
                }
            }
            catch (e) {
                res = false;
            }
            return res;
        },
        clear: function (key, storeType, domain) {
            var res;
            try {
                if (typeof storeType === 'string' && handleStorage[storeType]) {
                    res = handleStorage[storeType].clear(key, domain);
                }
                else if (domain) {
                    res = handleStorage.cookie.clear(key, domain);
                }
                else {
                    res = handleStorage.localStorage.clear(key) && handleStorage.sessionStorage.clear(key);
                }
            }
            catch (e) {
                res = false;
            }
            return res;
        }
    };
    return handleStorage;
})();function uuid() {
    function S4() {
        return (((1 + Math.random()) * 0x10000) | 0).toString(16).substring(1);
    }
    return (S4() + S4() + '-' + S4() + '-' + S4() + '-' + S4() + '-' + S4() + S4() + S4());
}var getMemory = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function () {
        var p = window.performance;
        var m = p.memory;
        var used = m.usedJSHeapSize || 0;
        var total = m.totalJSHeapSize || 1;
        var usedRatio = used / total;
        return {
            memory: usedRatio || 'N/A',
            used: used,
            total: total
        };
    };
})();
var getTiming = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function () {
        var p = window.performance;
        var t = p.timing;
        var timing_wscreen = timingFilter(t.responseStart - t.navigationStart);
        var timing_fscreen = timingFilter(t.loadEventEnd - t.navigationStart);
        var timing_network = timingFilter(t.responseEnd - t.navigationStart);
        var timing_network_prev = timingFilter(t.fetchStart - t.navigationStart);
        var timing_network_redirect = timingFilter(t.redirectEnd - t.redirectStart);
        var timing_network_dns = timingFilter(t.domainLookupEnd - t.domainLookupStart);
        var timing_network_tcp = timingFilter(t.connectEnd - t.connectStart);
        var timing_network_request = timingFilter(t.responseEnd - t.requestStart);
        var timing_render = timingFilter(t.responseStart - t.navigationStart);
        var timing_render_load = timingFilter(t.loadEventEnd - t.navigationStart);
        var timing_render_ready = timingFilter(t.domComplete - t.responseEnd);
        return {
            timing_wscreen: timing_wscreen,
            timing_fscreen: timing_fscreen,
            timing_network: timing_network,
            timing_network_prev: timing_network_prev,
            timing_network_redirect: timing_network_redirect,
            timing_network_dns: timing_network_dns,
            timing_network_tcp: timing_network_tcp,
            timing_network_request: timing_network_request,
            timing_render: timing_render,
            timing_render_load: timing_render_load,
            timing_render_ready: timing_render_ready
        };
    };
})();
var getSource = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (config) {
        return __awaiter(this, void 0, Promise, function () {
            function gen() {
                var len, _loop_1, i;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            len = s.length;
                            _loop_1 = function (i) {
                                var item, type, data, k;
                                return __generator(this, function (_a) {
                                    switch (_a.label) {
                                        case 0:
                                            item = s[i];
                                            type = item.initiatorType || '';
                                            data = {
                                                name: item.name,
                                                duration: +Number.prototype.toFixed.call(item.duration, 2),
                                                type: type
                                            };
                                            if (type === 'xmlhttprequest' || type === 'fetchrequest') {
                                                randomRatio(apiRatio) && timing_api_random.push(data);
                                                data.duration >= threshold && timing_api_timeout.push(data);
                                                if (getType(apis) === 'string') {
                                                    data.name === apis && timing_api_appoint.push(data);
                                                }
                                                else if (getType(apis) === 'array') {
                                                    apis.some(function (v) {
                                                        if (v === data.name) {
                                                            timing_api_appoint.push(data);
                                                            return true;
                                                        }
                                                        return false;
                                                    });
                                                }
                                            }
                                            else {
                                                randomRatio(sourceRatio) && timing_source_random.push(data);
                                                data.duration >= threshold && timing_source_timeout.push(data);
                                                if (getType(sources) === 'string') {
                                                    type === sources && timing_source_appoint.push(data);
                                                }
                                                else if (getType(sources) === 'array') {
                                                    sources.some(function (v) {
                                                        if (v === type) {
                                                            timing_source_appoint.push(data);
                                                            return true;
                                                        }
                                                        return false;
                                                    });
                                                }
                                                else if (getType(sources) === 'object') {
                                                    for (k in sources) {
                                                        if (k === type) {
                                                            sources[k].some(function (v) {
                                                                if (v === data.name) {
                                                                    timing_source_appoint.push(data);
                                                                    return true;
                                                                }
                                                                return false;
                                                            });
                                                        }
                                                    }
                                                }
                                            }
                                            return [4];
                                        case 1:
                                            _a.sent();
                                            return [2];
                                    }
                                });
                            };
                            i = 0;
                            _a.label = 1;
                        case 1:
                            if (!(i < len)) return [3, 4];
                            return [5, _loop_1(i)];
                        case 2:
                            _a.sent();
                            _a.label = 3;
                        case 3:
                            i++;
                            return [3, 1];
                        case 4: return [2];
                    }
                });
            }
            var _a, _b, apiRatio, _c, sourceRatio, _d, apis, _e, sources, p, s, timing_api_random, timing_api_timeout, timing_api_appoint, timing_source_random, timing_source_timeout, timing_source_appoint, threshold;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        _a = config || {}, _b = _a.apiRatio, apiRatio = _b === void 0 ? 0.1 : _b, _c = _a.sourceRatio, sourceRatio = _c === void 0 ? 0.1 : _c, _d = _a.apis, apis = _d === void 0 ? '' : _d, _e = _a.sources, sources = _e === void 0 ? '' : _e;
                        p = window.performance;
                        s = p.getEntriesByType('resource');
                        timing_api_random = [];
                        timing_api_timeout = [];
                        timing_api_appoint = [];
                        timing_source_random = [];
                        timing_source_timeout = [];
                        timing_source_appoint = [];
                        threshold = 2000;
                        return [4, timeslice(gen)];
                    case 1:
                        _f.sent();
                        return [2, {
                                timing_api_random: timing_api_random,
                                timing_api_timeout: timing_api_timeout,
                                timing_api_appoint: timing_api_appoint,
                                timing_source_random: timing_source_random,
                                timing_source_timeout: timing_source_timeout,
                                timing_source_appoint: timing_source_appoint
                            }];
                }
            });
        });
    };
})();
var getExecTiming = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function () {
        return __awaiter(this, void 0, Promise, function () {
            function gen() {
                var len, i, item;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            len = measures.length;
                            for (i = 0; i < len; i++) {
                                item = measures[i];
                                timing_exec.push({
                                    name: item.name,
                                    duration: item.duration
                                });
                            }
                            return [4];
                        case 1:
                            _a.sent();
                            return [2];
                    }
                });
            }
            var p, measures, timing_exec;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        p = window.performance;
                        measures = p.getEntriesByType('measure');
                        timing_exec = [];
                        return [4, timeslice(gen)];
                    case 1:
                        _a.sent();
                        return [2, {
                                timing_exec: timing_exec
                            }];
                }
            });
        });
    };
})();
var getPerformanceData = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (config) {
        return __awaiter(this, void 0, Promise, function () {
            var memo, memory, timings, sources, execTiming;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        memo = getMemory();
                        memory = memo.memory;
                        timings = getTiming();
                        return [4, getSource(config).then(function (data) { return data; })];
                    case 1:
                        sources = _a.sent();
                        return [4, getExecTiming().then(function (data) { return data; })];
                    case 2:
                        execTiming = _a.sent();
                        return [2, __assign({ memory: memory || 'N/A' }, timings, sources, execTiming)];
                }
            });
        });
    };
})();
var marks = [];
var measures = [];
var mark = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    return function (tag) {
        var p = window.performance;
        var mark = p.mark;
        var measure = p.measure;
        if (!~marks.indexOf(tag)) {
            mark(tag + "Start");
            marks.push(tag);
        }
        else if (!~measures.indexOf(tag)) {
            mark(tag + "End");
            measure("" + tag);
            measures.push(tag);
        }
        else {
            console.warn("Cannot repeat tag the mark: " + tag);
        }
    };
});
var clearPerformance = (function () {
    if (typeof window === 'undefined' || !window.performance)
        return notSupport;
    var p = window.performance;
    performance.clearMarks();
    performance.clearMeasures();
    performance.clearResourceTimings();
    marks.splice(0);
    measures.splice(0);
});
function timingFilter(timing) {
    if (isNaN(timing))
        return 'N/A';
    return timing > 0 ? timing : 0;
}
function randomRatio(ratio) {
    if (Math.random() <= ratio)
        return true;
    return false;
}var getEnvInfo = (function () {
    if (typeof window === 'undefined')
        return function () {
            console.warn('Please call in browser environment');
            return;
        };
    return function () {
        var ua = navigator.userAgent;
        var scr = window.screen;
        var page_url = location.href;
        var referer = document.referrer;
        var info = {
            ts: +Date.now(),
            os: '',
            browser: '',
            screen_size: (scr.width || 0) + 'x' + (scr.height || 0),
            page_url: page_url,
            referer: referer,
            device: ('ontouchstart' in window ? 'mobile' : 'pc'),
            ua: ua
        };
        function check(pattern) {
            return function () {
                return (pattern).test(ua);
            };
        }
        var UA = {
            isAndroid: check(/android/i),
            isIOS: check(/(ipad|iphone|ipod)/i),
            isWindows: check(/window/i),
            isMac: check(/mac os x/i),
            isChrome: check(/webkit\W.*(chrome|chromium)\W/i),
            isFirefox: check(/mozilla.*\Wfirefox\W/i),
            isGecko: check(/mozilla(?!.*webkit).*\Wgecko\W/i),
            is360se: check(/360/i),
            isIE: function () {
                if (navigator.appName === 'Microsoft Internet Explorer') {
                    return true;
                }
                else if (check(/\bTrident\b/)()) {
                    return true;
                }
                else {
                    return false;
                }
            },
            isEdge: check(/\bEdge\b/i),
            isOpera: check(/opera.*\Wpresto\W|OPR/i),
            isSafari: check(/webkit\W(?!.*chrome).*safari\W/i),
            isMobile: check(/(iphone|ipod|((?:android)?.*?mobile)|blackberry|nokia)/i),
            isWebKit: check(/webkit\W/i),
            isWeixin: check(/micromessenger/i),
            isSinaWeibo: check(/weibo/i),
            isQQ: check(/qq/i),
            isQQWeibo: check(/tencentmicroblog/i)
        };
        if (UA.isMobile()) {
            if (UA.isAndroid()) {
                info.os = 'android';
            }
            if (UA.isIOS()) {
                info.os = 'ios';
            }
            if (UA.isWeixin()) {
                info.browser = 'weixin';
            }
            if (UA.isSinaWeibo()) {
                info.browser = 'sinaBlog';
            }
            if (UA.isQQ()) {
                info.browser = 'qq';
            }
            if (UA.isQQWeibo()) {
                info.browser = 'qqBlog';
            }
        }
        else {
            if (UA.isWindows()) {
                info.os = 'windows';
            }
            if (UA.isMac()) {
                info.os = 'mac';
            }
            if (UA.isChrome()) {
                info.browser = 'chrome';
            }
            if (UA.isFirefox()) {
                info.browser = 'firefox';
            }
            if (UA.isIE()) {
                info.browser = 'ie';
            }
            if (UA.isOpera()) {
                info.browser = 'opera';
            }
            if (UA.isSafari()) {
                info.browser = 'safari';
            }
            if (UA.is360se()) {
                info.browser = '360';
            }
        }
        return info;
    };
})();var ExceptionTypes;
(function (ExceptionTypes) {
    ExceptionTypes[ExceptionTypes["js"] = 0] = "js";
    ExceptionTypes[ExceptionTypes["api"] = 1] = "api";
    ExceptionTypes[ExceptionTypes["source"] = 2] = "source";
})(ExceptionTypes || (ExceptionTypes = {}));
var jsErrors = [];
var apiErrors = [];
var sourceErrors = [];
var HandleException = {
    getErrors: function (type) {
        var typeIndex = type ? ExceptionTypes[type] : undefined;
        var errors;
        switch (typeIndex) {
            case ExceptionTypes['js']:
                errors = jsErrors;
                break;
            case ExceptionTypes['api']:
                errors = apiErrors;
                break;
            case ExceptionTypes['source']:
                errors = sourceErrors;
                break;
            default:
                errors = { jsErrors: jsErrors, apiErrors: apiErrors, sourceErrors: sourceErrors };
        }
        return errors;
    },
    setErrors: function (error) {
        var type = error.type;
        var typeIndex = ExceptionTypes[type];
        switch (typeIndex) {
            case ExceptionTypes['js']:
                jsErrors.push(error);
                break;
            case ExceptionTypes['api']:
                apiErrors.push(error);
                break;
            case ExceptionTypes['source']:
                sourceErrors.push(error);
                break;
        }
    }
};(function () {
    if (typeof window === 'undefined')
        return;
    addListener('error', function (e) {
        var filename = e.filename, message = e.message, error = e.error;
        HandleException.setErrors({
            type: 'js',
            url: filename || '',
            msg: message,
            error: error
        });
    }, window);
    addListener('DOMContentLoaded', function (e) {
        var imgs = transArray(document.querySelectorAll('img'));
        imgs.forEach(function (img) { return addListener('error', function (e) {
            var sourceType = 'img';
            var url = e.target.src;
            HandleException.setErrors({
                type: 'source',
                sourceType: sourceType,
                url: url
            });
        }, img); });
    }, window);
})();
function getError(type) {
    return HandleException.getErrors(type);
}
function setError(err) {
    HandleException.setErrors(err);
}
var ObserveError = (function () {
    function ObserveError(target, observeDom) {
        this.observer = this.init(target, observeDom);
    }
    ObserveError.prototype.init = function (target, observeDom) {
        if (!target)
            return console.warn('Please pass a vaild HTMLElement');
        var observer = new MutationObserver(function (doms) {
            var observeList = (observeDom && typeof observeDom === 'string' ? [observeDom] : observeDom) || ['img'];
            handleError(doms);
            function handleError(doms) {
                var len = doms.length;
                var _loop_1 = function (i) {
                    var item = (doms[i].addedNodes && doms[i].addedNodes[0]) || doms[i];
                    var nodeName = item.nodeName || '';
                    var sourceType = nodeName.toLowerCase();
                    if (~observeList.indexOf(sourceType)) {
                        addListener('error', function (e) {
                            var url = e.target.src;
                            HandleException.setErrors({
                                type: 'source',
                                sourceType: sourceType,
                                url: url
                            });
                        }, item);
                    }
                    if (item.children.length > 0) {
                        return { value: handleError(item.children) };
                    }
                };
                for (var i = 0; i < len; i++) {
                    var state_1 = _loop_1(i);
                    if (typeof state_1 === "object")
                        return state_1.value;
                }
            }
        });
        observer.observe(target, {
            'childList': true,
            'attributes': true
        });
        return observer;
    };
    ObserveError.prototype.cancel = function () {
        this.observer && this.observer.disconnect();
    };
    return ObserveError;
}());
function transArray(arrayLike) {
    return Array.prototype.slice.call(arrayLike);
}function makeTrackInfo(type, info) {
    var envInfo = getEnvInfo();
    if (type === 'pv') {
        var guid = storage.get('uuid', 'cookie');
        if (!guid) {
            type = 'uv';
            storage.set('uuid', uuid(), 'cookie', { expires: 86400 });
        }
    }
    return {
        general: envInfo,
        props: {
            type: type,
            info: info
        }
    };
}exports.ObserveError=ObserveError;exports.clearPerformance=clearPerformance;exports.getEnvInfo=getEnvInfo;exports.getError=getError;exports.getExecTiming=getExecTiming;exports.getMemory=getMemory;exports.getPerformanceData=getPerformanceData;exports.getSource=getSource;exports.getTiming=getTiming;exports.makeTrackInfo=makeTrackInfo;exports.mark=mark;exports.setError=setError;Object.defineProperty(exports,'__esModule',{value:true});}));
/* Copyright (c) 2019-2019 Bobby.li 
* MIT License 
*/